local sf = string.format
require 'nntp'

DATE = '020527' -- 27. may 2002
TIME = '012047' -- 1h 20 min 47 sec
server = 'news.gmane.org'
obj = assert(nntp.new(server))


print('I am permitted to post articles to this server:', obj.posting_ok)

print('GET ALL GROUPS HOSTED ON THIS SERVER')
lst = assert(obj:list())
print(sf("%-25s %7s %7s %6s", 'newsgroup', 'last', 'first', 'post'))
for k, v in pairs(lst) do
    print(sf("%-25s %7d %7d %6s", k, v[1], v[2], tostring(v[3])))
end

-- find a group with small noumber of articles for later use
for k, v in pairs(lst) do
    if  (v[1] - v[2] > 0) and (v[1] - v[2] < 20) then
        grp = k
        print('found small group:', k)
        break
    end
end

print('GET NEWGROUPS')
-- lst = assert(obj:newgroups(DATE, TIME))        -- servers local time and date
lst = assert(obj:newgroups(DATE, TIME, 'GMT')) -- gmt time and date
print(sf("%-25s %7s %7s %6s", 'newsgroup', 'last', 'first', 'post'))
for k, v in pairs(lst) do
    print(sf("%-25s %7d %7d %6s", k, v[1], v[2], tostring(v[3])))
end




print('GET NEWNEWS')
lst = assert(obj:newnews(grp, DATE, TIME))        -- servers local time and date
-- lst = obj:newnews(grp, DATE, TIME, 'GMT') -- gmt time and date
for k, v in ipairs(lst) do    print(v) end


print('JUST TEST IF SERVER IMPLEMENTS "SLAVE" COMMAND')
if obj:slave() then
    print('it does')
else 
    print('It does not')
end


print('QUIT THE CONNECTION WITH SERVER')
assert(obj:quit())

print 'CREATE NEW CONNECTION'
obj = assert(nntp.new{host=server, port=119})

print 'SELECT A GROUP'
count, first, last, gg = assert(obj:group(grp))
print(sf("%s has %d articles, first: %d last: %d", gg, count, first, last))

print 'SET "current article pointer" TO LAST ARTICLE'
msg_num, message_id = assert(obj:stat(last))

print 'TRAVERSE ALL ARTICLES IN GREOUP BACKWARDS'
repeat
    msg_num, message_id = assert(obj:stat())
    print(sf('article %d has message_id: %s', msg_num, message_id))
until not obj:last()

print 'TRAVERSE ALL ARTICLES IN GREOUP FORWARDS'
msg_num, message_id = assert(obj:stat(first))
repeat
    msg_num, message_id = assert(obj:stat())
    print(sf('article %d has message_id: %s', msg_num, message_id))
until not obj:next()


msg_num, message_id = assert(obj:stat(first))

print 'RETRIVE ATRICLE (and set "current article pointer"'
msg = assert(obj:article(msg_num))

print 'RETRIVE HEADER OF MESSAGE of current message'
head = assert(obj:head())

print 'RETRIVE BODY OF MESSAGE of same message identified by message_id'
body = assert(obj:body(message_id))

print 'TEST THAT ARTICLE, HEAD, AND BODY ARE THE SAME'
assert((function () return msg == head .. '\r\n' .. body end)(), 'message is different')

print 'Almost all function were tested'

print(obj:quit())
